<?php

namespace App\Filament\Exports;

use App\Models\ProductionQuantity;
use Filament\Actions\Exports\ExportColumn;
use Filament\Actions\Exports\Exporter;
use Filament\Actions\Exports\Models\Export;

class ProductionQuantityExporter extends Exporter
{
    protected static ?string $model = ProductionQuantity::class;

    public static function getColumns(): array
    {
        static $rowNumber = 0;

        return [
            // ExportColumn::make('id')
            //     ->label('ID'),
            ExportColumn::make('no')
                ->label('NO')
                ->state(function ($record) use (&$rowNumber) {
                    // Increment and return the row number
                    return ++$rowNumber;
                }),
            ExportColumn::make('production_order')
                ->label('PRODUCTION ORDER'),
            ExportColumn::make('serial_number')
                ->label('SERIAL NUMBER'),
            ExportColumn::make('item.code')
                ->label('ITEM CODE'),
            ExportColumn::make('item.uom')
                ->label('UNIT OF MEASURE'),
            ExportColumn::make('line.name')
                ->label('LINE NAME'),
            ExportColumn::make('shift.block.name')
                ->label('BLOCK NAME'),
            ExportColumn::make('shift.name')
                ->label('SHIFT NAME'),
            ExportColumn::make('plant.code')
                ->label('PLANT CODE'),
            ExportColumn::make('sap_msg_status')
                ->label('SAP MESSAGE STATUS'),
            ExportColumn::make('sap_msg_description')
                ->label('SAP MESSAGE DESCRIPTION'),
            ExportColumn::make('operator_id')
                ->label('OPERATOR ID'),
            ExportColumn::make('created_at')
                ->label('CREATED AT'),
            ExportColumn::make('updated_at')
                ->label('UPDATED AT'),
            ExportColumn::make('deleted_at')
                ->enabledByDefault(false)
                ->label('DELETED AT'),
        ];
    }

    public static function getCompletedNotificationBody(Export $export): string
    {
        $body = 'Your production quantity export has completed and '.number_format($export->successful_rows).' '.str('row')->plural($export->successful_rows).' exported.';

        if ($failedRowsCount = $export->getFailedRowsCount()) {
            $body .= ' '.number_format($failedRowsCount).' '.str('row')->plural($failedRowsCount).' failed to export.';
        }

        return $body;
    }
}
